<pre><div class="text_to_html">import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.PlugInFilter;
import java.util.Arrays;

public class Filter_Median5 implements PlugInFilter {

public int setup(String arg, ImagePlus imp) {
		return DOES_ALL;
	}


	public void run(ImageProcessor orig) {
	            int  w = orig.getWidth();        
  		int  h = orig.getHeight();	

		ImageProcessor copy  = orig.duplicate();
	
  
		int[] P = new int[9];     //Vector to hold Pixel from 3x3 matrix

		for (int v = 1; v <= h-2 ; v++) {
    		   for (int u = 1; u <= w-2; u++) {
                       
		      int k = 0;
                       	for (int j=-1; j<=1; j++){
                          for (int i=-1; i<=1; i++){
			P[k] = copy.getPixel(u+i,v+j);
			k++;
			}
		}
	
 		    Arrays.sort(P);
		    orig.putPixel(u,v, P[4]);
		   }
		}
		
	}

}

</div></pre>