<pre><div class="text_to_html">import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;
import ij.IJ;
import ij.ImagePlus;
import ij.gui.GenericDialog;
import ij.plugin.filter.PlugInFilter;
import ij.process.ImageProcessor;


public class Filter_Laplace implements PlugInFilter {
	ImagePlus imp;

   


	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_ALL;
	}

	public void run(ImageProcessor orig) {

                       int w = orig.getWidth();
                       int h = orig.getHeight();

                       double [] [] filter1 = {
                          {   0 , 1 ,  0 },
                          { 1, -4 , 1},
                          {   0 ,  1,  0 }
                        };
                       double [] [] filter2 = {
                          {  1 , 2 ,  1 },
                          { 0 , 0 , 0 },
                          {  -1 ,  -2,  -1 }
                        };
                       ImageProcessor copy = orig.duplicate();
                        

                        for (int v = 1; v <= h-2; v++) {
                               for (int u = 1; u <= w-2; u++){
                                   
                                  double sum1 = 0; 
                                //  double sum2 = 0; 

                                   for (int j = -1; j <= 1; j++) {
                                     for (int i = -1; i <= 1; i++){
                                   
                                      int p = copy.getPixel(u-i,v-j);

                                      double c1 = filter1[j+1][i+1];

                                 //     double c2 = filter2[j+1][i+1];

                                       sum1 =  sum1 + p*c1 ;
                                  //     sum2 = sum2 + p*c2;
                                    }
                                  }
                                 int q = (int) Math.round(sum1);  
                                 // int q = (int) Math.round(Math.sqrt(sum1*sum1+sum2*sum2));  
                                 orig.putPixel(u,v,q);       
	                          }
                              }
                         }




}
</div></pre>